/* 
** PS2 KBD Test
**
** 
** LDJ 6/9/06  v1.0
** WVD 06/04/08 - Add support for PIC24FJ256GB110 and PIC24FJ256GA110
*/

#include <p24Fxxxx.h>

#include "PS2T4.h"

#define PLL_96MHZ_ON    0xF7FF
#if defined(__PIC24FJ256GB110__)     // GB110 requires PLLDIV etc, else clocks fail to turn on
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // 128GA010 and 256GA110  PIMs
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif


main()
{
    TRISA = 0xff00;
    initKBD();			// call the initialization routine

    while ( 1)
    {
        if ( KBDReady)		// wait for the flag 
        {
            PORTA = KBDCode; 	// fetch the key code and publish on PORTA
            KBDReady = 0; 		// clear the flag 
        }
    } // main loop
} //main
