//
// Bresenham.c
//
// Bresenham algorithm example
//

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS(int use_sdi1);        // PPS support for GB110 and GA110 PIMs

#include <stdlib.h>

#include "../graphic/graphic.h"

main()
{
    int i;

#if defined(__PIC24FJ256GB110__)  ||  defined(__PIC24FJ256GA110__)
    init_PPS (0);            // uses OC3, OC4
#endif

    // initializations
    initVideo();    // start the state machines
    srand( 12);
    
    // main loop
	while( 1)
	{   
        clearScreen();
        line( 0, 0, 0, VRES-1);
        line( 0, VRES-1, HRES-1, VRES-1);
        line( HRES-1, VRES-1, HRES-1, 0);
        line( 0, 0, HRES-1, 0);
    
        for( i = 0; i<100; i++) 	
            line( rand()%HRES, rand()%VRES, rand()%HRES, rand()%VRES);
        while( 1)
        {        
            if ( !_RD6)
                break;
        } // wait for a key

	} // main loop

} // main
