//
// Line Test1.c
//
// testing the basic line drawing function
//
// 06/17/08 - GB110 PIM currently is NOT allowing me to directly
//            manipulate RG2 (D+ of USB), even though I do not
//            need nor want to USB function to operate in this example.
//            GB110 PIM re-maps RG2 output to the RG0 pin on Explorer16
//            which is used for SYNC pulse.
// ??? What is ODG2 ???
//            Output in watch window shows that LATG2 is never set = 1
//             "          "      "              U1CON    = 0x0000
//                                              U1CNFG1  = 0x0020
//                                              U1CNFG2  = 0x0000
//                                              U1OTGCON = 0x0000
//                                              U1PWRC   = 0x0080 
//             ==> how do you disable USB, or is it always on ?
//                 If USB is always on, then this example will not work with GB110
//
// Caution: PIC24FJ256GB110 PIM will not work for this example
//          because it requires both OC3 and SPI1, which are re-mapped
//          to the same pin (77) on the GB110 PIM.
// ??? but does SPI1 really need SDI1/pin77 ? Is is it don't care.
//     GA110 also breaks, so maybe best bet is to have both
//     use the "cross-over" trick and run SPI2
//          PIC24FJ256GA110 will work, but it requires that SPI2 be used,
//          and we "cross-over" the SPI1/SPI signals on the Explorer16

#include <p24Fxxxx.h>

#define PLL_96MHZ_ON    0xF7FF
#if defined(__PIC24FJ256GB110__)     // GB110 requires PLLDIV etc, else clocks fail to turn on
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // 128GA010 and 256GA110  PIMs
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS(int use_sdi1);        // PPS support for GB110 and GA110 PIMs

#include "../graphic/graphic.h"


main()
{
    int x;
    float x0 = 10, y0 = 20, x1 = 200, y1 = 150, x2 = 20, y2 = 150;

#if defined(__PIC24FJ256GB110__)  ||  defined(__PIC24FJ256GA110__)
    init_PPS (0);            // uses OC3, OC4
#endif

    // initializations
    clearScreen();  // init the video map
    initVideo();    // start the video state machine

    // draw an oblique line (x0,y0)  (x1,y1)
    for( x=x0; x<x1; x++)
        plot( x, y0+(y1-y0)/(x1-x0)* (x-x0));

    // draw a second (steeper) line (x0,y0)  ( x2,y2)
    for( x=x0; x<x2; x++)
        plot( x, y0+(y2-y0)/(x2-x0)* (x-x0));

    x = 0;       // WVD debug hook
    // main loop    
	while( 1)
	{   
 
	} // main loop

} // main
