/*
**  The Matrix2
**
**  LDJ v2.0 5/30/06
*/
#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS(int use_sdi1);        // PPS support for GB110 and GA110 PIMs

#include "../TextG/TextOnGPage.h"

#define COL     40
#define ROW     23
#define DELAY 12000

#define pcr() {cx = 0; cy++;}
    
main()
{
    int v[40];  // vector containing lengh of each string
    int i,j,k;

#if defined(__PIC24FJ256GB110__)  ||  defined(__PIC24FJ256GA110__)
    init_PPS (0);            // uses OC3, OC4
#endif

    // 1. initializations
    T1CON = 0x8030; // TMR1 on, prescale 256, Tcy/2

    initVideo();
    Clrscr();       // clear the screen
    srand( 12);     // start the random number sequence
    
    // 2. init each column lenght
    for( j =0; j<COL; j++)
            v[j] = rand()%ROW;
    
    // 3. main loop
    while( 1)
    {
        Home();
        
        // 3.1 refresh the screen with random columns
        for( i=0; i<ROW; i++)
        {
            
            // refresh one row at a time
            for( j=0; j<COL; j++)
            {
                // print a random character down to each column lenght
                if ( i < v[j])
                    putcV( 'A' + (rand()%32));
                else 
                    putcV(' ');
//                putcV( ' ');
            } // for j
            pcr();
            
        } // for i

            // 3.1.1 delay to slow down the screen update
            TMR1 =0;   
            while( TMR1<DELAY);
        // 3.2 randomly increase or reduce each column lenght
        for( j=0; j<COL; j++)
        {
            switch ( rand()%3)
            {
                case 0: // increase length
                        v[j]++;
                        if (v[j]>ROW)
                            v[j]=ROW;
                        break;
                        
                case 1: // decrease length
                        v[j]--;
                        if (v[j]<1)
                            v[j]=1;
                        break;
                        
                default:// unchanged 
                        break;
             } // switch
        } // for

    } // main loop
} // main
