/*
** Text Page Test
**
*/

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS(int use_sdi1);        // PPS support for GB110 and GA110 PIMs

#include "../graphic/graphic.h"
#include "../textg/TextOnGPage.h"

main( void)
{
    int i;

#if defined(__PIC24FJ256GB110__)  ||  defined(__PIC24FJ256GA110__)
    init_PPS (0);            // uses OC3, OC4
#endif

    // initializations
    initVideo();    // start the state machines
    
    Clrscr();
    
    AT( 0, 0);
    putsV( "FLYING THE PIC24!");
        
    AT( 0, 2);
    for( i=32; i<128; i++)
	    putcV( i);

    while (1);

} // main
