/*
** Plotting a 1D function graph
** 
**
*/

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS(int use_sdi1); // PPS support for GB110 and GA110 PIMs

#include <math.h>

#include "../graphic/graphic.h"

#define X0 10
#define Y0 (VRES/2)
#define PI 3.141592654f

main( void)
{
    int x, y;
    float xf, yf;

#if defined(__PIC24FJ256GB110__)  ||  defined(__PIC24FJ256GA110__)
    init_PPS (0);            // uses OC3, OC4
#endif

    // initializations
    clearScreen();
    initVideo();    

    // draw the x and y axes crossin in (X0,Y0)
    line( X0, 10, X0, VRES-10);     // y axes
    line( X0-5, Y0, HRES-10, Y0);   // x axes 
    
    // plot the graph of the function for 
    for( x=0; x<200; x++)
    {
        xf = (2 * PI / 50) * (float) x;
        yf =  75.0 / ( 8 * PI) * xf * sin( xf);
        plot( x+X0, yf+Y0);
    }

    // main loop
    while( 1);

} // main
