/********1*********2*********3*********4*********5*********6*********7**********
*
* 	ReadTest.c
* 
* Be sure to set HEAP size to at least 4000 bytes, else mount() will
* fail during malloc() phase.  Project -> Build Options -> Project -> PIC32 Linker
*
* History:
*   07/21/06 v1.0 created.  LDJ
*   05/30/08 - Revised to checkout PIC24FJ256GB110/GA110 PIMs with AV32 board.
*              PIC24FJ256GB110/GA110 PIMs require use of ~/pps/pps.c. W Duquaine
*******************************************************************************/

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS (int use_sdi1);

#include "../13 SDMMC/SDMMC.h"
#include "fileio.h"
#include "../delay/delay.h"
#include "../8 comm/conu2.h"


#define B_SIZE  10
char data[ B_SIZE];


int  main ( void)
{
    MFILE *fs;
    unsigned r;

       //initializations
    init_PPS (0);           // init PPS configuration
    initU2();               // 115,200 baud 8,n,1
 
    putsU2 ( "init");
    while ( !detectSD());   // assumes SDCD pin is by default an input
    Delayms( 100);          // wait for card to power up
        
    putsU2 ("media detected");

    if ( mount())
       {
        putsU2 ( "mount");
        if ( (fs = fopenM( "source.txt", "r")))
          {
            putsU2("file opened");
            do {
                r = freadM( data, B_SIZE, fs);
////            for( i=0; i<r; i++)
///               putU2( data[i]);
               } while( r==B_SIZE);
            fcloseM ( fs);
            putsU2 ("file closed");
          } 
         else
            putsU2 ("could not open file");

        unmount();
        putsU2 ("media unmounted");        
       }
    
             // main loop
    while( 1);
}                  // main
