/*
*  Test SD card interface
*
* Be sure to set HEAP size to at least 3000 bytes, else mount() will
* fail during malloc() phase.  Project -> Build Options -> Project -> PIC32 Linker
*
* History:
*   07/7/06 LDJ v. 2.0
*   05/30/08 - Revised to checkout PIC24FJ256GB110/GA110 PIMs with AV32 board.
*              PIC24FJ256GB110/GA110 PIMs require use of ~/pps/pps.c. W Duquaine
*/

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif

#include "stdlib.h"
#include "sdmmc.h"
#include "fileio.h"

unsigned char buffer[512];

main( void)
{
    int i, r; 
    MFILE *fp;
    char data[512];

    TRISA = 0xff00;
    initSD();

    while ( !detectSD());       // wait for card to be inserted

    if ( mount()== NULL)
        PORTA = FError + 0x80;
    else
    {
        PORTA = 0xFF;
        for( i=1; i<100; i++)
        {
            fp = fopen( "GRAPH2D.TXT", "r");
            if ( fp == NULL)    
                break;
            else
            {   // read entire file content
                while( (r = fread( data, 512, fp) == 512));
                Nop(); Nop();
                // close file
                fclose( fp);
            } // fopen
        } // for
        PORTA = 0;
    } // mounted

    while( 1)
    {
    } // main loop

} // main
