//
// More pattern work
//
// LDJ 11/19/05
//

#include <p24Fxxxx.h>

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)

// 1. define timing constant
#define SHORT_DELAY 5
#define LONG_DELAY	80

// 2. declare and initialize an array with the message bitmap 
char bitmap[30] = { 
	0b11111111,	// H
	0b00001000,
	0b00001000,
	0b11111111,
	0b00000000,
	0b00000000,
	0b11111111,	// E
	0b10001001,
	0b10001001,
	0b10000001,
	0b00000000,
	0b00000000,
	0b11111111,	// L
	0b10000000,
	0b10000000,
	0b10000000,
	0b00000000,
	0b00000000,
	0b11111111,	// L
	0b10000000,
	0b10000000,
	0b10000000,
	0b00000000,
	0b00000000,
	0b01111110,	// O
	0b10000001,
	0b10000001,
	0b01111110,
	0b00000000,
	0b00000000
	};
	
// 3. the main program
main()
{
	// 3.1 variable declarations
	int i;				// i will serve as the index 
	
	// 3.2 initialization
	TRISA = 	0;		// all PORTA as output
	T1CON =   0x8030;   // TMR1 on, prescale 1:256 Tclk/2
	
	// 3.3 the main loop   	
	while( 1)
	{
		// 3.3.1 display loop, hand moving to the right
		for( i=0; i<30; i++)
		{	// 3.3.1.1 update the LEDs
			PORTA = bitmap[i];
				
			// 3.3.1.2 short pause
			TMR1 = 		0;
			while ( TMR1 < SHORT_DELAY)
			{
			}
		} // for i
			
		// 3.3.2 long pause, hand moving back to the left
		PORTA = 0;		// turn LEDs off
		TMR1 = 		0;
		while ( TMR1 < LONG_DELAY)
		{
		}
	} // main loop
} // main
