/*
** NVM Library test
*/ 

#include <p24Fxxxx.h>

#include "NVM.h"

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                          // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
// Note: the MPLAB Config Defaults do not work with PIC24FJ256GB110 (no clocks enabled).
// If the above PLL_96MHZ_ON is not defined, you get:
//   ICD0083: Debug: Unable to enter debug mode. Please double click this message for more information. 


main()
{
	int data;

	// initialize the SPI2 port and CS to access the 25LC256
	InitNVM();
	
	// main loop
	while ( 1)
	{
		// read current content of memory location
		data = iReadNVM( 0x1234);
	
		// increment current value
		Nop();			// <-set brkpt here
		data++;				
		
		// write back the new value
		iWriteNVM( 0x1234, data);
		//address++;
		
	} // main loop
} //main
