/*
** CONU2 Test
** UART2 RS232 asynchronous communication demonstration code
*/

#include <p24Fxxxx.h>
#include "conU2.h"

#if defined( __PIC24FJ256GB110__ ) || defined( __PIC24FJ256GB106__ )
#define PLL_96MHZ_ON    0xF7FF
_CONFIG1(ICS_PGx2 & JTAGEN_OFF & FWDTEN_OFF)        // JTAG off, watchdog timer off
_CONFIG2( FNOSC_PRIPLL & PLL_96MHZ_ON & PLLDIV_DIV2 & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_XT)
#else                   // PIC24FJ128GA010 and PIC24FJ256GA110
_CONFIG1( ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF) 
_CONFIG2( FNOSC_PRIPLL & OSCIOFNC_OFF & FCKSM_CSDCMD & POSCMOD_HS)
#endif
void  init_PPS (int use_sdi1);


#define BUF_SIZE 128


main()
{
    char s[BUF_SIZE];

	// 0. init PPS configuration 
    init_PPS (0);

	// 1. init the console serial port 
    initU2();
	
	// 2. text prompt 
    clrscr();
    home();
    puts( "Learn to fly with the PIC24!\r");
    sprintf( s, "Learn to fly the PIC24! %d\r", 17);
    puts( s);
    
	// 3. main loop
	while ( 1)
	{
		// 3.1 read a full line of text
          getsn( s, sizeof(s));

		// 3.2 send a string to the serial port
          puts( s);
				
		// 3.3 send a carriage return
	  pcr();
		
	} // main loop
	
}// main
